#!/usr/bin/env python3.5
# -*- coding: utf_8 -*-

#	CDBI	Horloge-33	Juillet 2018	01 Mars 2019
#	à partir du Script de 2007 de Yves Le Chevalier
#	sur Codes-Sources

import sys,os
import time
from datetime import datetime
from tkinter import *
from tkinter.filedialog import askdirectory
from tkinter.filedialog import askopenfilename
from tkinter import messagebox
import PIL.Image
import PIL.ImageTk
from math import *
from time import *
from subprocess import call
import pickle
import RPi.GPIO as GPIO
sys.path.append("./Lib")
#Librairie générale
import clsCDBI
lib1=clsCDBI.CDBI1()

global  hala , mala, heuala, iala, ichro, t0, Config, iafd
hala, mala, heuala, iala, ichro, t0, Config, iafd = 0, 0, 0, 0, 0, 0, 0, 0

def config_GPIO():
	global P1,P2,cptP2
	GPIO.setmode(GPIO.BCM)
	GPIO.setwarnings(False)
	#Config idem au boitier PI3BP
	# on met les GPIO 22 et 27 à UP avec event bas
	P1=27	#Arret Alarme/Chrono
	GPIO.setup(P1, GPIO.IN, pull_up_down=GPIO.PUD_UP)
	GPIO.add_event_detect(P1,GPIO.FALLING,callback=callbackP1,bouncetime=200)
	P2=22	#Mode Affichage
	GPIO.setup(P2, GPIO.IN, pull_up_down=GPIO.PUD_UP)
	GPIO.add_event_detect(P2,GPIO.FALLING,callback=callbackP2,bouncetime=200)
	cptP2=1		#Compteur d'appui sur P2

def choixA():
	global Applicmd
	f=askopenfilename(initialdir="./",
		filetypes=[("Bash", "*.sh")],
		title="Choisir une Tache")
	try:
		with open(f,'r') as nF:
			Applicmd= f + " &"
			Appliala.set(Applicmd)
			Entreecmd.configure(fg="darkgreen")
			Entreecmd.focus()
	except:
		#on change rien
		Applicmd=Entreecmd.get()
		Appliala.set(Applicmd)

def choixD():
	global DP
	EntreeP.focus()
	if lib1.Existe(DP):
		Idir=DP
	else:
		Idir="/media/pi/"
	rep=askdirectory(initialdir=Idir,title='Choisir un Dossier de Photos')
	if len(rep) > 0:
		EntreeP.configure(fg="darkgreen")
		DP=rep
		DossierPhoto.set(rep)
		photo=[]
		indP=0
		if VarCadre.get() == True:
			if charge_photo(DP) == False:
				VarCadre.set(False)
				EntreeP.configure(fg="red")
			else:
				EntreeP.configure(fg="darkgreen")
	
def charge_photo(DP):
	global photo
	photo=[]
	if messagebox.askyesno("CADRE-PHOTOS","Chargements:\n" + DP) == False:
		return False

	lib1.DIT("Chargement Photos",VarSon.get())
	#Recherche dans Dossier photo et liste photo des PhotoImage pour TK
	for entry in os.scandir(DP):
		try:
			fpath=entry.path
			if fpath.endswith(('.jpg','JPG','.gif','GIF')):
				img=PIL.Image.open(fpath)
				wi=img.width
				hi=img.height
				rap=wi/hi
				#Adapte à la taille de l'écran avec proportions
				he=scrH-Hmenu-20
				img=img.resize((int(he*rap),int(he)),PIL.Image.ANTIALIAS)
				photo.append(PIL.ImageTk.PhotoImage(img))
		except:
			lib1.DIT("Erreur Chargement",VarSon.get())
			print (fpath)
			continue
	if len(photo) == 0:
		return False
	else:
		return True

def callbackP1(p):
	global flagALA
	e1 = GPIO.input(P1)
	if flagALA:
		sleep(1)
	else:
		sleep(0.5)
	e2 = GPIO.input(P1)
	if e1 != e2:
		if flagALA:
			flagALA=False
			lib1.DIT("alarme OK",VarSon.get())
			sleep(0.5)
			afala.configure(bg='lightgreen')
		else:
			chrono()

def callbackP2(p):
	global flagPHOTO,flagDIGITAL,cptP2,Config,w
	global TP
	e1 = GPIO.input(P2)
	sleep(0.5)
	e2 = GPIO.input(P2)
	if e1 != e2:
		cptP2 +=1
		w=ancw
		if cptP2 > 4:
			cptP2=1
		if not VarCadre.get() and cptP2 == 3:
			#on saute les photos
			cptP2=4
		if cptP2 == 1:
			flagDIGITAL=False
			flagPHOTO=False
			Config=True
			TP=0
			dessine_config()
		elif cptP2 == 2:
			set_Digital()
		elif cptP2 == 3:
			set_photo()
		elif cptP2 == 4:
			flagDIGITAL=False
			flagPHOTO=False
			Config=False
			TP=0
			dessine_config()


def LIRE_Config(f):
	global Applicmd,Appliala,heuala,iala,VS
	global DossierPhoto,DP
	global DureePhoto,DUP
	if lib1.Existe(f):
		try:
			nF=open(f,'rb')
			ConfDATA=pickle.load(nF)
			nF.close()
			Applicmd=ConfDATA['Appli']
			Appliala.set(Applicmd)
			DP=ConfDATA['DossierP']
			DossierPhoto.set(DP)
			DUP=ConfDATA['DureeP']
			DureePhoto.set(DUP)
			heuala=ConfDATA['HeureAla']
			iala=ConfDATA['Ala']
			VarAppli.set(ConfDATA ['ChkAp'])
			VarSon.set(ConfDATA ['ChkSon'])
			VS=int(VarSon.get())
			VarH4.set(ConfDATA ['ChkCari'])
			VarCadre.set(ConfDATA['ChkCadre'])
			VarAngelus.set(ConfDATA ['angelus'])
			Rb1.set(ConfDATA ['RbCari'])
			VarNuit.set(ConfDATA ['nuit'])
			return True
		except:
			nF.close
			return False
	else:
		return False

def ENR_Config(f):
	nF=open(f,'wb')
	#Mise des données en Dictionaire
	ConfDATA= {
		'Appli': Applicmd,
		'DossierP': DP,
		'DureeP': DureePhoto.get(),
		'HeureAla': heuala,
		'Ala': iala,
		'ChkAp': VarAppli.get(),
		'ChkSon': VarSon.get(),
		'ChkCari': VarH4.get(),
		'ChkCadre' : VarCadre.get(),
		'RbCari': Rb1.get(),
		'angelus': VarAngelus.get(),
		'nuit' : VarNuit.get(),
		}
	pickle.dump(ConfDATA,nF)
	nF.close()

def appli(event):
	#Return de la commande Appli
	global Applicmd,Appliala
	Applicmd=str(Entreecmd.get())
	if Applicmd == "":
		Applicmd="Pas d'Application définie"
	Appliala.set(Applicmd)
	Entreecmd.configure(fg="darkgreen")
	
def dossierp(event):
	#Return du Dossier Photos et chargement si cadre validé
	global photo,indP
	global DossierPhoto,DP
	DP=str(EntreeP.get())
	if lib1.Existe(DP):
		EntreeP.configure(fg="darkgreen")
		DossierPhoto.set(EntreeP.get())
		photo=[]
		indP=0
		if VarCadre.get() == True:
			if charge_photo(DP) == False:
				VarCadre.set(False)
				EntreeP.configure(fg="red")
			else:
				EntreeP.configure(fg="darkgreen")
	else:
		EntreeP.configure(fg="red")

def dureep(event):
	#return Durée Photo
	global DureePhoto,DUP
	DUP=str(EntreeDP.get())
	DureePhoto.set=EntreeDP.get()
	EntreeDP.configure(fg="darkgreen")

def dessine_horloge(w):
	can1.create_oval(26, 26, w-36, w-36, fill='', width=20,outline='gold')
	can1.create_oval(18, 18, w-28, w-28, fill='', width=3,outline="yellow")
	can1.create_oval(14, 14, w-24, w-24, fill='', width=5,outline="black")
	can1.create_oval(35, 35, w-45, w-45, fill='', width=2,outline="blue")
	#Centre des Aiguilles    
	can1.create_oval(w/2-14,w/2-14,w/2+6,w/2+6, fill='gold',outline='blue',width=2,tag="axe")
	i = 1
	while i < 61 :
		j = i*((2*pi)/60)
		# diametre et centre
		d=w/2-30
		ce=w/2-5
		x=(cos(j)*d)+ce
		y=(sin(j)*d)+ce
		if w > 200:
			ep=6
		else:
			ep=4
		can1.create_oval(x-ep+4, y-ep+4, x+ep-4, y+ep-4, fill='blue')
		if i in (15,30,45,60):
			can1.create_oval(x-ep, y-ep, x+ep, y+ep, fill='blue')
		if i in (5,10,20,25,35,40,50,55):
			can1.create_oval(x-ep+2, y-ep+2, x+ep-2, y+ep-2, fill='blue')
		i +=1
	if iala:
		dessine_AigAla(w)

def aff_heure() :
	global hala, mala, heuala,iafd,t0,w,can1,canP
	global heurd,minud
	global TP,indP,idP
	jours=['lundi','mardi','mercredi','jeudi','vendredi','samedi','dimanche']
	mchrono=0
	dateheure=localtime()
	a=dateheure[0]
	m=dateheure[1]
	j=dateheure[2]
	jj=jours[dateheure[6]]
	heur=dateheure[3]
	minu=dateheure[4]
	seco=dateheure[5]
	heurd=heur
	minud=minu
	secod=seco
	couchro="blue"

	if Config:
		w=200
	else:
		w=ancw

	if heur >12 :
		heur = heur -12
	if ichro == 1:
		iafd=False
		t1=(dateheure[3]*3600)+(dateheure[4]*60)+dateheure[5]
		tchro = t1 - t0
		hchro = int(tchro/3600)
		mchro = int((tchro-(hchro*3600))/60)
		schro=tchro-(hchro*3600)-(mchro*60)
		#change couleur selon nombre de tours pair/impair
		if (int(tchro/60)%2 == 0):
			couchro="blue"
		else:
			couchro="red"
			
	if flagPHOTO and len(photo) > 0:
		#on rempli l'écran
		fen1.geometry("+0-2")
		if secod == 0:
			TP=int(DUP)
		if TP == 0:
			TP=secod
		if secod == TP:
			TP=secod+int(DUP)
			#Efface la photo précédente
			canP.delete(idP)
			indP +=1
			if indP >= len(photo):indP=0
			idP=canP.create_image(int(scrW/2),int((scrH-10)/2),image=photo[indP])
			inf=str(indP+1) + "/" + str(len(photo)) + ">" + lib1.Extract_Chemin(DP,False)
			inf = inf + "     " + '%d' %heurd + ":" + '%02d' %minud + ":" +'%02d' %secod
			inf = inf + "     " + '%02d' %j + "/" + '%02d' %m + "/" + '%04d' %a
			infoP.configure(text=inf)
			
		else:
			inf=str(indP+1) + "/" + str(len(photo)) + ">" + lib1.Extract_Chemin(DP,False)
			inf = inf + "     " + '%d' %heurd + ":" + '%02d' %minud + ":" +'%02d' %secod
			inf = inf + "     " + '%02d' %j + "/" + '%02d' %m + "/" + '%04d' %a
			infoP.configure(text=inf)

	elif flagDIGITAL == True:
		#Affiche date et heure en Digital
		labDATE.configure(text = jj + "-" + '%02d' %j + "/" + '%02d' %m + "/" + '%04d' %a)
		#afficher heure digitale ou Chrono
		if iafd:
			labDIGIT.configure(text = '%d' %heurd + ":" + '%02d' %minud + ":" +'%02d' %secod,fg='green')
		elif ichro == 1:
			labDIGIT.configure(text = '%d' %hchro+'.%02d' %mchro+'.%02d'%schro,fg='blue')
		elif ichro == 2:
			labDIGIT.configure(fg='red')
		elif ichro == 0 :
			#on remet l'affichage Heure
			iafd=True
	else:
		#Remet fen1 en position de départ
		fen1.geometry("+" + str(X0) + "+" + str(Y0))
		# redéfini les aiguilles
		# affiche heures Horloge
		ce=w/2-5
		heur=heur+(minu/60.00)
		j=(heur+9)*((2*pi)/12)
		l=w/2-65
		x=(cos(j)*l)+ce
		y=(sin(j)*l)+ce
		can1.coords(aigheu, ce, ce, x, y)
		# affiche minutes
		minu=minu+(seco/60.0)
		j=(minu+45)*((2*pi)/60)
		l=w/2-45
		x=(cos(j)*l)+ce
		y=(sin(j)*l)+ce
		can1.coords(aigmin, ce, ce, x, y)
		# affiche secondes
		j=(seco+45)*((2*pi)/60)
		l=w/2-40
		x=(cos(j)*l)+ce
		y=(sin(j)*l)+ce
		can1.coords(aigsec, ce, ce, x, y)

		#afficher heure digitale ou Chrono
		if iafd:
			afdigi.configure(text = '%d' %heurd + ":" + '%02d' %minud + ":" +'%02d' %secod)
		elif ichro == 1:
			afdigi.configure(text = '%d' %hchro+'.%02d' %mchro+'.%02d'%schro)
			#Pointage des secondes Chrono sur l'extérieur
			l=w/2-15
			x=(cos(j)*l)+ce
			y=(sin(j)*l)+ce
			can1.create_oval(x-2, y-2, x+2, y+2, fill=couchro, outline=couchro)
		elif ichro == 0 :
			#on remet l'affichage Heure
			iafd=True

	#pas de Son la nuit entre 23h et 7h
	if VarNuit.get() and heurd in (23,0,1,2,3,4,5,6,7):
		VarSon.set(False)
	else:
		VarSon.set(VS)

	#Détection de l'Alarme en premier
	if heurd == hala and minud == mala and secod == 0 and iala == True :
		Alarme()
	#si avec le son, si carillon 1/4h  si Angelus
	elif (VarSon.get() == True):
		if VarAngelus.get() == True and heurd in (7,19) and minud == 0 and secod == 0:
			Cari_Angelus()
		elif minud in (0,2) and secod == 0:
			Cari_Heure(heurd)
		elif minud in (15,30,45) and VarH4.get() == True and secod == 0:
			Cari_Minu()

	#on relance toutes les 999 mS pour avoir les secondes
	can1.after(999,aff_heure)

def dessine_config() :
	global can3,w
	global choixala,iala,Config,Entreecmd,EntreeP,EntreeDP
	global hala,mala,VarAppli,VarH4
	global cptP2
	if Config == True:
		Config=False
		#on remet en mode normal
		w=ancw
		dessine_principal(w)

	elif Config == False:
		Config = True
		cptP2=0
		w=200
		dessine_principal(w)
		for i in range (1,4):
			menuBarre.entryconfig(i,state=DISABLED)
		can3 = Frame(fen1, bg='lightblue',bd=5,width=500,height=130)

		Entreecmd=Entry(can3,textvariable=Appliala,font=("Arial",12),width=54,bg="white")
		Entreecmd.configure(validate="key")
		Entreecmd.bind("<Return>",appli)
		Entreecmd.place(x=0,y=5)
		
		EntreeP=Entry(can3,textvariable=DossierPhoto,font=("Arial",12),width=54,bg="white")
		EntreeP.place(x=0,y=35)
		EntreeP.configure(validate="key")
		EntreeP.bind("<Return>",dossierp)

		curs= Scale(can3, from_=0.00, to=24.00, length=480, sliderlength=10,
					resolution=0.01, showvalue=0, orient=HORIZONTAL,
					label="Réglage de l'alarme :",command=choix_alarme,font=('Arial', 9),fg='blue',bg="lightblue")
		curs.place(x=2,y=60)
		curs.bind("<Enter>",curseur_main)
		curs.bind("<Leave>",curseur_fleche)
		
		choixala = Label(can3,font=('Arial', 11,'bold'),fg='red',bg="lightblue")
		choixala.configure(text = "Déclencher l'alarme à " +'% d' %hala +" h. " +'%02d' %mala)
		choixala.place(x=2,y=100)

		bouchoixA= Button(can3,text="...",command=choixA)
		bouchoixA.place(x=472,y=5,width=20,height=24)
		bouchoixA.bind("<Enter>",curseur_main)
		bouchoixA.bind("<Leave>",curseur_fleche)

		bouchoixP= Button(can3,text="...",command=choixD)
		bouchoixP.place(x=472,y=35,width=20,height=24)
		bouchoixP.bind("<Enter>",curseur_main)
		bouchoixP.bind("<Leave>",curseur_fleche)

		can3.pack(side=BOTTOM)

		labD=Label(can1,text="Durée(s)",font=('Arial',10),bg="lightgrey",fg='blue')
		labD.place(x=400,y=10)
		
		EntreeDP=Entry(can1,textvariable=DureePhoto,font=("Arial",12),width=3,bg="white")
		EntreeDP.place(x=456,y=10)
		EntreeDP.configure(validate="key")
		EntreeDP.bind("<Return>",dureep)
		
		bouon=Button(can1, text="Ala.On", command=seton_alarme,font=('Arial',10),bg='lightgreen')
		bouon.place(x=420,y=80)
		bouon.bind("<Enter>",curseur_main)
		bouon.bind("<Leave>",curseur_fleche)

		bouoff=Button(can1, text="Ala.Off", command=setoff_alarme,font=('Arial',10),bg='pink')
		bouoff.place(x=420,y=130)
		bouoff.bind("<Enter>",curseur_main)
		bouoff.bind("<Leave>",curseur_fleche)

		bouS=Button(can1, text="Essais Sons", command=Essais_Son,font=('Arial',10),bg='lightyellow')
		bouS.place(x=280,y=170)
		bouS.bind("<Enter>",curseur_main)
		bouS.bind("<Leave>",curseur_fleche)
		
		check1=Checkbutton(can1,text="Cadre Photo",variable=VarCadre,command=Modif_Cadre,font=('Arial',10),bg="lightgrey",fg='blue')
		check1.place(x=270,y=10)
		check1.bind("<Enter>",curseur_main)
		check1.bind("<Leave>",curseur_fleche)

		check2=Checkbutton(can1,text="Sonne 1/4 h",variable=VarH4,font=('Arial',10),bg="lightgrey",fg='blue')
		check2.place(x=270,y=35)
		check2.bind("<Enter>",curseur_main)
		check2.bind("<Leave>",curseur_fleche)

		check3=Checkbutton(can1,text="Angelus 7/19h",variable=VarAngelus,font=('Arial',10),bg="lightgrey",fg='blue')
		check3.place(x=270,y=60)
		check3.bind("<Enter>",curseur_main)
		check3.bind("<Leave>",curseur_fleche)

		rbou1=Radiobutton(can1,text="H.Parlante",variable=Rb1,value=1,font=('Arial',10),bg="lightgrey",fg='blue')
		rbou1.place(x=270,y=85)
		rbou1.bind("<Enter>",curseur_main)
		rbou1.bind("<Leave>",curseur_fleche)
		
		rbou2=Radiobutton(can1,text="Carillon",variable=Rb1,value=2,font=('Arial',10),bg="lightgrey",fg='blue')
		rbou2.place(x=270,y=105)
		rbou2.bind("<Enter>",curseur_main)
		rbou2.bind("<Leave>",curseur_fleche)

		check4=Checkbutton(can1,text="Lancer Application",variable=VarAppli,font=('Arial',10),bg="lightgrey",fg='blue')
		check4.place(x=270,y=135)
		check4.bind("<Enter>",curseur_main)
		check4.bind("<Leave>",curseur_fleche)
		
		check5=Checkbutton(can1,text="Pas la Nuit",variable=VarNuit,font=('Arial',10),bg="lightgrey",fg='blue')
		check5.place(x=390,y=35)
		check5.bind("<Enter>",curseur_main)
		check5.bind("<Leave>",curseur_fleche)

		lab1=Label(can1,text=str(scrW) + "x" + str(scrH))
		lab1.place(x=420,y=185)

		can1.pack()

		hala=int(heuala)
		mala=int((heuala - hala) * 60)
		choixala.configure(text = "Déclencher l'alarme à " +'%d' %hala +" h. " +'%02d' %mala)
		curs.set (heuala)

def dessine_principal(w):
	global can1,can2,can3,canP,TP,infoP
	global aigala,aigheu,aigmin,aigsec,afdigi
	global hala,mala,afala,indala
	global check2
	global labDIGIT,labDATE,labALA

	hala=int(heuala)
	mala=int((heuala - hala) * 60)

	if can1 != None:can1.destroy()
	if can2 != None:can2.destroy()
	if can3 != None:can3.destroy()
	if canP != None:canP.destroy()
	fen1.geometry("+" + str(X0) + "+" + str(Y0))

	if flagPHOTO:
		menuBarre.entryconfig(0,state=DISABLED)
		menuBarre.entryconfig(1,state=DISABLED)
		menuBarre.entryconfig(2,state=DISABLED)
		menuBarre.entryconfig(3,font=('Arial',10,'bold'))
		canP = None
		TP=0
		canP = Canvas(fen1,width=scrW-5,height=scrH-Hmenu,bd=4,bg='lightgrey')
		infoP=Label(canP,font=('Arial',16,'bold'),fg='green',bg='lightgrey')
		infoP.place(x=5,y=1)
		canP.pack()
		aff_heure()		#l'Horloge sert de Timer

	elif flagDIGITAL:
		menuBarre.entryconfig(0,state=DISABLED)
		menuBarre.entryconfig(1,state=ACTIVE)
		menuBarre.entryconfig(2,state=ACTIVE)
		menuBarre.entryconfig(2,font=('Arial',10,'bold'))
		menuBarre.entryconfig(3,font=('Arial',10))
		can2 = Canvas(fen1,bg='lightyellow',bd=4)
		can2.configure(relief='raised',width=w,height=int(w/2.2))

		checkSon=Checkbutton(can2,text="Son",variable=VarSon,command=set_son,font='Arial,10',bg="lightyellow",fg='blue')
		checkSon.place(x=270,y=10)
		checkSon.bind("<Enter>",curseur_main)
		checkSon.bind("<Leave>",curseur_fleche)
		
		labALA=Label(can2,bg='lightyellow',font=('Arial',16))
		labALA.place(x=5,y=5)
		if iala:
			labALA.configure(fg='red')
		else:
			labALA.configure(fg='grey')
		if VarAppli.get() == 1:
			labALA.configure(text='Programme: %d' %hala + ":" +'%02d' %mala)
		else:
			labALA.configure(text='Alarme: %d' %hala + ":" +'%02d' %mala)

		labDATE=Label(can2,text='',bg='lightyellow',fg='green',font=('Arial',22))
		labDATE.place(x=5,y=30)

		labDIGIT=Label(can2,bg='lightyellow',fg='green',font=('Arial',int(w/5.5)))
		labDIGIT.place(x=w/25,y=60)

		can2.pack(expand=YES,fill=BOTH)
		aff_heure()

	else:
		menuBarre.entryconfig(0,state=ACTIVE)
		menuBarre.entryconfig(1,state=ACTIVE)
		menuBarre.entryconfig(2,state=ACTIVE)
		menuBarre.entryconfig(2,font=('Arial',10))
		menuBarre.entryconfig(3,font=('Arial',10))
		if VarCadre.get():
			menuBarre.entryconfig(3,state=ACTIVE)
		else:
			menuBarre.entryconfig(3,state=DISABLED)
		can1 = Canvas(fen1,bg='lightgrey',bd=4)
		can1.configure(relief='raised',width=w,height=w)
		
		#Création des Aiguilles elles seront configurées ensuite
		aigala = can1.create_line(10,10,10,5, fill='', width=2,arrow=LAST)
		aigheu = can1.create_line(10,10,10,5, fill='blue', width=6,arrow=LAST)
		aigmin = can1.create_line(10,10,10,5, fill='blue', width=4,arrow=LAST)
		aigsec = can1.create_line(10,10,10,5, fill='green', width=2,arrow=LAST)
		indala=can1.create_oval(10,10,10,5,fill='red')

		afdigi = Label(can1, font=('Arial',18,'bold'),fg="blue")
		afdigi.place(x=10,y=w-30)

		afala=Label(can1,font=('Arial',12,'bold'))
		afala.place(x=w-65,y=6)

		checkSon=Checkbutton(can1,text="Son",variable=VarSon,command=set_son,font='Arial,10',bg="lightgrey")
		checkSon.bind("<Enter>",curseur_main)
		checkSon.bind("<Leave>",curseur_fleche)

		if Config == False:
			checkSon.place(x=5,y=8)
		else:
			checkSon.destroy()
			afdigi.configure(font=('Arial',12,'bold'))
			afdigi.place(x=5,y=w-25)

		if logo != None:
			can1.create_image(w-30,w-20,image=logo,tag="cd")
			can1.tag_bind("cd","<ButtonRelease>",aff_infos)
			can1.tag_bind("cd","<Enter>",curseur_main)
			can1.tag_bind("cd","<Leave>",curseur_fleche)

		can1.pack(expand=YES,fill=BOTH)
		dessine_horloge(w)
		dessine_AigAla(w)
		aff_heure()

def dessine_AigAla(w):
	#Dessine l'Aiguille de l'Alarme et affiche l'heure d'Alarme
	if iala == 1:
		#j=(hala+9+(mala/60.00))*((2*pi)/12)
		j=(heuala+9)*((2*pi)/12)
		l=w/2-40
		ce=w/2-5
		x=(cos(j)*l)+ce
		y=(sin(j)*l)+ce
		can1.coords(aigala, ce, ce, x, y)
		if heuala>12:
			coul="red"
		else:
			coul="magenta"
		can1.itemconfigure(aigala,fill=coul)
		#Si on n'est pas en Config on met le pointeur
		if not Config:indala=can1.create_oval(x-3, y-3, x+3, y+3, fill=coul)
		afala.configure(fg=coul)
	else:
		afala.configure(fg='grey')
	if VarAppli.get() == 1:
		afala.configure(text='P %d' %hala + ":" +'%02d' %mala)
	else:
		afala.configure(text='A %d' %hala + ":" +'%02d' %mala)

def choix_alarme(valcurs) :
	global  hala, mala, heuala
	heuala=float(valcurs)
	hala=int(heuala)
	mala=int((heuala - hala) * 60)
	dessine_AigAla(w)
	choixala.configure(text = "Déclencher l'alarme à " +'%d' %hala +" h." +'%02d' %mala)

def seton_alarme() :
	global iala, Config
	iala=True
	can1.destroy()
	can3.destroy()
	w=ancw
	Config=False
	dessine_principal(w)
	dessine_AigAla(w)
	ENR_Config(FichierConf)

def setoff_alarme() :
	global iala, Config
	iala=False
	can3.destroy()
	can1.destroy()
	Config=False
	w=ancw
	dessine_principal(w)
	ENR_Config(FichierConf)

def Alarme():
	global flagALA
	flagALA=True
	try:
		lib1.DIT('il est ' + str(hala) + "heure " + str(mala),VarSon.get())
		if VarAppli.get() == 1:
			flagALA=False
			call(Applicmd,shell=True)
		else:
			f="./Alarme.wav"
			if lib1.Existe(f):
				cmd="aplay -q -f S16_LE -r 16000 " + f + " &"
				cpt=0
				while flagALA and cpt < 5:
					call(cmd,shell=True)
					sleep(10)
					cpt += 1
				flagALA=False
			else:
				flagALA=False
				raise
	except:
		flagALA=False
		return

def chrono() :
	global ichro, t0
	if ichro == 0 :
		ichro = 1
		dateheure=localtime()
		t0=(dateheure[3]*3600)+(dateheure[4]*60)+dateheure[5]
		menuBarre.entryconfig(0,state=DISABLED)
		menuBarre.entryconfig(1,font=('Arial',10,'bold'))
		menuBarre.entryconfig(2,state=DISABLED)
		menuBarre.entryconfig(3,state=DISABLED)
	elif ichro == 1 :
		ichro = 2
	else :
		ichro = 0
		#on efface
		if not flagDIGITAL:can1.create_oval(10, 10, w-20,w-20, fill='', width=6,outline='lightgrey')
		menuBarre.entryconfig(0,state=ACTIVE)
		menuBarre.entryconfig(1,font=('Arial',10))
		menuBarre.entryconfig(2,state=ACTIVE)
		menuBarre.entryconfig(3,state=ACTIVE)
		
def Essais_Son():
	
	f="./Alarme.wav"
	if lib1.Existe(f):
		#on force le mode Carillon pour le test
		x=Rb1.get()
		Rb1.set(0)
		lib1.DIT("alarme",True)
		lib1.Lire_WAV(f)
		lib1.DIT("carillon Heure",True)
		Cari_Heure(1)
		lib1.DIT("carillon minute",True)
		Cari_Minu()
		lib1.DIT("Angelus",True)
		Cari_Angelus()
		#on remet
		Rb1.set(x)

def Cari_Heure(h):
	if Rb1.get() == 1:
		lib1.DIT("il est " + str(heurd) + "heure  ",True)
	else:
		if h > 12: h=h-12
		f="./CariH.wav"
		for i in range(h):
			lib1.Lire_WAV(f)

def Cari_Minu():
	if Rb1.get() == 1:
		lib1.DIT("il est " + str(heurd) + "heure " + str(minud),True)
	else:
		f="./CariM.wav"
		lib1.Lire_WAV(f)

def Cari_Angelus():
	if Rb1.get() == 1:
		lib1.DIT("il est " + str(heurd) + "heure " + str(minud),True)
	else:
		for i in range(3):
			Cari_Minu()
		sleep(0.5)
		Cari_Heure(9)
		sleep(0.5)
		for i in range(3):
			Cari_Minu()

def set_Digital():
	global flagDIGITAL,flagPHOTO
	flagPHOTO=False
	flagDIGITAL= not flagDIGITAL
	can1.destroy()
	dessine_principal(w)

def aff_infos(e) :
	feninf = Toplevel()
	feninf.config(bg='lightblue')
	geo1=fen1.winfo_geometry()
	geox=fen1.winfo_rootx()
	geoy=fen1.winfo_rooty() 
	feninf.geometry("220x270+" + str(geox) + "+" + str(geoy))
	feninf.title("À propos")
	labinf=Label(feninf, bg='lightblue',fg='black',width=50,font=('Arial', 9),
		text= "Horloge 3.2\n"
			"Merci à Yves Lechevalier\n\n"
			"CDBI Juin 2018\n\n"
			"Ce programme affiche une horloge\n"
			"ou un cadre Photos\n"
			"avec une alarme sur 24h\n"
			"     un chronomètre\n"
			"     un affichage digital\n\n"
			"Choix entre une Alarme sonore\n"
			"ou le lancement d'un Programme\n"
			"Carillon sur Heure et 1/4 Heure\n"
			"ou Horloge parlante\n\n"
			"Sauvegarde de la Configuration")
	labinf.pack()
	bouf3=Button(feninf, text="Fermer", command=feninf.destroy,bg="orange", fg='brown')
	bouf3.pack(side=BOTTOM,pady=5)
	#feninf.transient()
	#feninf.grab_set()
	feninf.wait_window()

def curseur_main(e) :
	fen1.config(cursor='hand2')

def curseur_fleche(e) :
	fen1.config(cursor='arrow')

def Modif_Cadre():
	if VarCadre.get() == True:
		if charge_photo(DP) == False:
			VarCadre.set(False)
	else:
		indP=0
		photo=[]

def Fermer():
	global photo
	ENR_Config(FichierConf)
	photo=[]
	fen1.quit()
	GPIO.cleanup()
	sys.exit(0)

def set_son():
	global VS
	VS=int(VarSon.get())
	ENR_Config(FichierConf)

def set_photo():
	global flagPHOTO,flagDIGITAL,indP
	if len(photo) > 0 and VarCadre.get():
		flagPHOTO=not flagPHOTO
		#indP=-1
		dessine_principal(w)

# =========================MAIN===============================
global w	#Largeur de la fenetre passée en argument (300 minimum)
global ancw	#Largeur de la config
racine=sys.path[0]
w=0
wmin=350
FichierConf=racine + "/horloge.conf"

fen1 = Tk(className='Horloge-3.4')
    
can1=None
can2=None
can3=None
canP=None
Appliala=StringVar()
iala=False
Config=False
Applicmd=""
DossierPhoto=StringVar()
DP=""
VarAppli=IntVar()
VarSon=IntVar()
VarH4=IntVar()
Rb1=IntVar()
VarAngelus=IntVar()
VarPhoto=IntVar()
DureePhoto=StringVar()
VarCadre=IntVar()
VarNuit=IntVar()
flagPHOTO=False
flagDIGITAL=False
flagALA=False	#Alarme déclenchée
DUP=""
VS=1
X0=0
Y0=0
logo=None
photo=[]
TP=0
indP=-1
idP=0
Hmenu=50		#gap sur la position H pour tenir compte Hauteur menu

#Taille Ecran
tscreen=lib1.Taillescreen()
scrW=int(tscreen[0])
scrH=int(tscreen[1])

if not LIRE_Config(FichierConf):
	Applicmd="Pas d'Application définie"
	Appliala.set(Applicmd)
	iala=False
	DP="Pas de Dossier Photos"
	DossierPhoto.set(DP)
	heuala=0
	iala=False
	VarAppli.set(0)
	VarSon.set(0)
	VarH4.set(0)
	VarAngelus.set(0)
	DureePhoto.set(5)
	Rb1.set(1)
	VarNuit.set(1)
	VarCadre.set(0)
sleep(0.1)

#Ligne de commande
#print (sys.argv)
if len(sys.argv) > 1:
	ancw = int(sys.argv[1])
	if ancw < 0:
		#Centrage Ecran
		ancw=abs(ancw)
		if ancw<wmin:ancw=wmin
		X0=int((scrW-ancw)/2)
		Y0=int((scrH-ancw-Hmenu)/2)
	else:
		#Position donnée en Arguments
		if ancw<wmin: ancw=wmin
		if len(sys.argv) == 3:
			X0 = int(sys.argv[2])
			Y0=100
		elif len(sys.argv) == 4:
			X0 = int(sys.argv[2])
			Y0 = int(sys.argv[3])
		elif len(sys.argv) == 5:
			X0 = int(sys.argv[2])
			Y0 = int(sys.argv[3])
	if len(sys.argv) == 5:
		VarCadre.set(int(sys.argv[4]))
else:
	ancw=wmin
	X0=int((scrW-ancw)/2)
	Y0=100

if Applicmd == "":
	Applicmd="Pas d'Application définie"
	Appliala.set(Applicmd)

#position de départ
fen1.geometry("+" + str(X0) + "+" + str(Y0))
fen1.resizable(width=False, height=False)
fen1.configure(bg='light blue')

w=ancw

menuBarre = Menu(fen1,tearoff=0)
menuBarre.add_command(label='Config...',command=dessine_config)
menuBarre.add_command(label='Chrono',command=chrono)
menuBarre.add_command(label='Digitale',command=set_Digital)
menuBarre.add_command(label='Photo',command=set_photo)
menuBarre.add_command(label='Fermer',command=Fermer)

fen1.config(menu=menuBarre)

#PhotoImage doit etre en global car TK efface l'image
#Utiliser PIL pour autre que GIF et mettre les images en liste
f=racine + "/Cdpetit.gif"
if lib1.Existe(f):
	logo=PhotoImage(file=f)
	
dessine_principal(w)

if VarCadre.get():
	if charge_photo(DP) == False:
		menuBarre.entryconfig(3,state=DISABLED)
		VarCadre.set(False)
else:
	menuBarre.entryconfig(3,state=DISABLED)
config_GPIO()
fen1.mainloop()

